<?php
/*
Plugin Name: Dashboard xkcd
Description: This plugin adds a dashboard widget with the most recent xkcd comic strip.
Version: 0.3
Author: voldemortensen
Author URI: https://www.garthmortensen.com
License: GPLv2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.html
Text Domain: dashboard-xkcd
*/

function dx_add_widget() {
	wp_add_dashboard_widget(
		'dashboard-xkcd',
		__( 'Dashboard xkcd', 'dashboard-xkcd' ),
		'dx_display_strip'
	);
}
add_action( 'wp_dashboard_setup', 'dx_add_widget' );

function dx_display_strip() {
	$rss = fetch_feed( 'http://xkcd.com/rss.xml' );
	if ( ! is_wp_error( $rss ) ) {
		$maxitems = $rss->get_item_quantity( 1 );
		$strips = $rss->get_items( 0, $maxitems );
		$allowed_html = array(
			'a' => array(
				'href' => array(),
				'title' => array(),
				'style' => array()
			),
			'img' => array(
				'src' => array(),
				'alt' => array(),
				'title' => array()
			),
			'div' => array(
				'style' => array()
			),
			'br' => array()
		);
		echo "<h3>" . wp_kses( $strips[0]->get_title(), $allowed_html ) . "</h3>";
		echo wp_kses( $strips[0]->get_content(), $allowed_html );
	}
}

function dx_style() {
	?>
<style type='text/css'>#dashboard-xkcd img{ max-width: 100%;}</style>
	<?php
}
add_action( 'admin_head-index.php', 'dx_style' );
